VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} GroupCal 
   Caption         =   "Group Calendar"
   ClientHeight    =   6612
   ClientLeft      =   36
   ClientTop       =   336
   ClientWidth     =   6144
   OleObjectBlob   =   "GroupCal.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "GroupCal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ********************************************************************
' * GroupCal 1.0                                                     *
' *                                                                  *
' *  Requirements:                                                   *
' *  --------------                                                  *
' *  - CDO (optional part of Outlook Setup)                          *
' *  - Outlook 2000, English - US (or the dates will not work)       *              *
' *  - Exchange Server                                               *
' *  - Manually Created Local Appointments Folder                    *
' *                                                                  *
' ********************************************************************



Dim targetfolder As Outlook.MAPIFolder  ' The folder to store all the appts in
Dim olns As NameSpace
Dim allrecips As Object                 ' The list of calendar owners that you pick
Dim Gsession As MAPI.Session            'CDO Session which provides the AB UI
Dim cdorecip As MAPI.Recipient
Dim myrecip As Outlook.Recipient


Private Sub cancelbutton_Click()
Unload Me
End
End Sub

Private Sub cmdchoose_Click()

' Use CDO to get the resolved names from an address book dialog
Set Gsession = CreateObject("MAPI.Session")
Gsession.Logon
    
mystatus.Caption = "Resolving Names from Address Book ..."
On Error GoTo canceladd
Set allrecips = Gsession.AddressBook(Title:="Select Calendars", forceResolution:=True, recipLists:=1, tolabel:="Calendars")
fortext.Caption = ""
For Each cdorecip In allrecips
    fortext.Caption = fortext.Caption & cdorecip.Name & ";"
Next
    
' Get rid of the trailing semicolon
fortext.Caption = Left(fortext.Caption, Len(fortext.Caption) - 1)

canceladd:
mystatus.Caption = ""
Err.Clear
End Sub

Private Sub createbutton_Click()

' Make sure the target folder is a calendar folder
If targetfolder.DefaultItemType <> olAppointmentItem Then
    MsgBox targetfolder.Name & " is not a calendar folder.", vbExclamation, "Invalid Folder"
    Exit Sub
End If


' Don't allow the primar calendar folder to be used for the group calendar
' Since all existing items are removed from the folder during processing
primarycalid = olns.GetDefaultFolder(olFolderCalendar).EntryID
targetcalid = targetfolder.EntryID

If primarycalid = targetcalid Then
    MsgBox "You cannot use your primary calendar to store the group information.  Create a new calendar folder using File-New-Folder and specify the new folder as the target folder for the group calendar.", , "Invalid Calendar Folder"
    Exit Sub
End If

' Make sure some calendars were picked
If allrecips.Count = 0 Then
MsgBox "You must specify some calendars."
Exit Sub
End If


'Clean out the folder
mystatus.Caption = "Removing Old Items ..."
DoEvents
While targetfolder.Items.Count > 0
targetfolder.Items.Remove 1
Wend
mystatus.Caption = ""

'Call the Sub to get the appts
Call Gatherappts
mystatus.Caption = "All Done."

Dim logitem As PostItem
Set logitem = olns.GetDefaultFolder(olFolderInbox).Items.Add("IPM.Post")
logitem.Subject = "Group Calendar Log Entry"
logitem.Body = "Group Calendar created in folder " & targetfolder.Name & " on " & CStr(Now()) & " with a total of " & CStr(targetfolder.Items.Count) & " items."
logitem.Body = logitem.Body & Chr(13) & "Date Range: " & fromtext.Text & " -" & totext.Text
logitem.Body = logitem.Body & Chr(13) & "Calendars Specified: " & fortext.Caption
logitem.Save
Set logitem = Nothing
End Sub


Sub Gatherappts()

Dim myrange, mycol, oneap As Object
Dim rquery As String

' Append times to the specified start and end date
tdystart = fromtext.Text & " 12:00 AM"
tdyend = totext.Text & " 11:59 PM"

'Build the restrict query
rquery = "[Start] >= """ & tdystart & """ and [Start] <= """ & tdyend & """"

Set olns = Application.GetNamespace("MAPI")

' Loop through all the recipients and get appointments
For Each cdorecip In allrecips

' Create an OUTLOOK recipient, because the CDO Recipient cant be
' used with Getdefaultsharedfolder
    Set myrecip = olns.GetRecipientFromID(cdorecip.ID)
    
    mystatus.Caption = "Processing Calendar for: " & myrecip.Name
    DoEvents

    Set olappts = Nothing
    numtestitems = 0
    On Error Resume Next
    Set olappts = olns.GetSharedDefaultFolder(myrecip, olFolderCalendar)
    Err.Clear
        
    numtestitems = olappts.Items.Count
             
    If numtestitems = 0 Then
        MsgBox "An error occurred connecting to " & myrecip.Name & "'s calendar.  Make sure: " & Chr(13) & "* The e-mail name is correct." & Chr(13) & "* The other person has given permissions to you." & Chr(13) & "* There is at least one appointment in the other person's calendar." & Chr(13) & "* You are using a Microsoft Exchange Server."
    Else
        Set mycol = olappts.Items
        mycol.Sort "[Start]"
        mycol.IncludeRecurrences = True
        Set myrange = mycol.Restrict(rquery)
        mystatus.Caption = "Adding Appointments from: " & myrecip.Name
        DoEvents
        For Each oneap In myrange
          If ValidAppt(oneap.MessageClass, oneap.Start) Then
            Set Addone = targetfolder.Items.Add
            Addone.Start = oneap.Start
            Addone.End = oneap.End
            Addone.Subject = myrecip.Name & ": " & oneap.Subject
            Addone.Location = oneap.Location
            Addone.Categories = myrecip.Name
            Addone.Save
            mystatus.Caption = "Added: " & oneap.Subject
            Set Addone = Nothing
          End If
        Next
        
    End If

    Set myrecip = Nothing
Next

End Sub

Function ValidAppt(MC As String, validstart As Date)

'Valid Appointments have one of the below two message classes.  The OLE one is
' the message class of a recurring appointment.
ValidAppt = True
If Left(MC, 15) <> "IPM.Appointment" And Left(MC, 13) <> "IPM.OLE.CLASS" Then ValidAppt = False
End Function

Private Sub pfolder_Click()

' This lets you pick the target folder
On Error GoTo canceled
Set targetfolder = olns.PickFolder
Me.fname.Caption = targetfolder.Name
Exit Sub
canceled:
Set targetfolder = Application.ActiveExplorer.CurrentFolder
Me.fname.Caption = targetfolder.Name

End Sub

Sub UserForm_Initialize()
Set olns = Application.GetNamespace("MAPI")
Set targetfolder = Application.ActiveExplorer.CurrentFolder
Me.fname.Caption = targetfolder.Name
fromtext.Text = Format(Now(), "MM/DD/YYYY")
totext.Text = Format(DateAdd("d", 7, Now()), "MM/DD/YYYY")
End Sub


Private Sub UserForm_Terminate()
    On Error Resume Next
    Gsession.Logoff
    Set Gsession = Nothing
End Sub
